import pygame
from pygame.locals import *
from . import text

WIDTH = 1280
HEIGHT = 720

surface = None
screen = None


def init():
    pygame.display.set_caption("Geom Demo")
    pygame.mouse.set_visible(False)
    global surface
    global screen

    surface = pygame.display.set_mode((WIDTH, HEIGHT))
    text.init()

    from .screen import Screen
    screen = Screen()


def loop():
    for event in pygame.event.get(QUIT):
        return False

    surface.fill((0, 0, 0))

    screen.render(surface)

    pygame.display.update()
    return True
